using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Collections;

using DVM_Management_Center.FileIO;
using DVM_Management_Center.Objects;

namespace DVM_Management_Center.GUI
{
    public partial class ConfigSite : Form
    {
        String mipPath = Application.StartupPath;
        String action = "";
        DVMObject[] dvmObjects;
        Hashtable hashDVMObjects;

        public const int START_WIDTH = 304;
        public const int EXTENDET_WIDTH = 612;

        private DVMObject[] _dvmObjects;
        public DVMObject[] DVMObjects
        {
            get { return _dvmObjects; }
            set { _dvmObjects = value; }
        }

        private int _positionTop = 0;
        public int PositionTop
        {
            get { return _positionTop; }
            set { _positionTop = value; }
        }

        private int _positionLeft = 0;
        public int PositionLeft
        {
            get { return _positionLeft; }
            set { _positionLeft = value; }
        }

        private string _imgFile;
        public string ImgFile
        {
            get { return _imgFile; }
            set { _imgFile = value; }
        }

        public ConfigSite()
        {
            InitializeComponent();
        }

        private void btCloseClick(object sender, EventArgs e)
        {
            gbAdd.Visible = false;
            btDelete.Enabled = true;
            btEdit.Enabled = true;
            lstBox.Enabled = true;
            
            this.Width = START_WIDTH;
            gbAdd.Visible = false;
            this.Close();
        }

        private void btDel_Click(object sender, EventArgs e)
        {
            if (lstBox.SelectedIndex != -1)
            {
                hashDVMObjects.Remove(lstBox.SelectedIndex);
                lstBox.Items.RemoveAt(lstBox.SelectedIndex);
                Hashtable tempHash = new Hashtable();
                int i = 0;
                foreach (DVMObject dvmObject in hashDVMObjects.Values)
                {
                    tempHash.Add(i, dvmObject);
                    i++;
                }
                i = 0;
                hashDVMObjects.Clear();
                foreach (DVMObject dvmObject in tempHash.Values)
                {
                    hashDVMObjects.Add(i, dvmObject);
                    i++;
                }
            }
        }

        private void btAdd_Click(object sender, EventArgs e)
        {
            action = "add";
            tbIP.Text = "";
            tbRComm.Text = "";
            tbWComm.Text = "";
            _positionLeft = 0;
            _positionTop = 0;
            gbAdd.Visible = true;
            gbAdd.Text = "Add a dvm";

            lstBox.Enabled = false;
            btEdit.Enabled = false;
            btDelete.Enabled = false;
            tbIP.Focus();

            this.Width = EXTENDET_WIDTH;
        }

        private void btCancel_Click(object sender, EventArgs e)
        {
            gbAdd.Visible = false;
            btDelete.Enabled = true;
            btEdit.Enabled = true;
            lstBox.Enabled = true;

            this.Width = START_WIDTH;
            gbAdd.Visible = false;
        }

        private void btSave_Click(object sender, EventArgs e)
        {
            RegExpressions regEx = new RegExpressions();
            if(regEx.GetSearchResult(tbIP.Text, @"^(\d{1,2}|1\d\d|2[0-4]\d|25[0-5])\.(\d{1,2}|1\d\d|2[0-4]\d|25[0-5])\.(\d{1,2}|1\d\d|2[0-4]\d|25[0-5])\.(\d{1,2}|1\d\d|2[0-4]\d|25[0-5])$").Count == 0)
            {
                MessageBox.Show("Your entry is not a valid ip.");
                tbIP.Focus();
            }
            else
            {
                if (action == "add")
                {
                    DVMObject dvmObject = new DVMObject();
                    dvmObject.Ip = tbIP.Text;
                    dvmObject.SiteName = tbIP.Text;
                    dvmObject.RComm = tbRComm.Text;
                    dvmObject.WComm = tbWComm.Text;
                    dvmObject.Left = _positionLeft.ToString();
                    dvmObject.Top = _positionTop.ToString();

                    lstBox.Items.Add(tbIP.Text);
                    hashDVMObjects.Add(hashDVMObjects.Count, dvmObject);
                }
                else // action == "edit"
                {
                    ((DVMObject)hashDVMObjects[lstBox.SelectedIndex]).Ip = tbIP.Text;
                    ((DVMObject)hashDVMObjects[lstBox.SelectedIndex]).SiteName = tbIP.Text;
                    ((DVMObject)hashDVMObjects[lstBox.SelectedIndex]).RComm = tbRComm.Text;
                    ((DVMObject)hashDVMObjects[lstBox.SelectedIndex]).WComm = tbWComm.Text;
                    ((DVMObject)hashDVMObjects[lstBox.SelectedIndex]).Left = _positionLeft.ToString();
                    ((DVMObject)hashDVMObjects[lstBox.SelectedIndex]).Top = _positionTop.ToString();
                }
                gbAdd.Visible = false;
                btDelete.Enabled = true;
                btEdit.Enabled = true;
                lstBox.Enabled = true;
                this.Width = START_WIDTH;
            }
        }

        private void ConfigSite_Load(object sender, EventArgs e)
        {
            this.Width = START_WIDTH;
            hashDVMObjects = new Hashtable();
            lstBox.Items.Clear();
            if (_dvmObjects == null)
                _dvmObjects = new DVMObject[0];
            for (int i = 0; i< _dvmObjects.Length; i++)
            {
                lstBox.Items.Insert(i, _dvmObjects[i].SiteName);
                hashDVMObjects.Add(i, _dvmObjects[i]);
            }
        }

        private void btSetPosition_Click(object sender, EventArgs e)
        {
            SetPosition setPosition = new SetPosition();
            setPosition.PbMap = new PictureBox();
            try
            {
                setPosition.PbMap.Load(_imgFile);
            }
            catch
            {
                MessageBox.Show("The background-image could not be loadet. Please check the map-settings!");
            }
            
            setPosition.PositionLeft = _positionLeft;
            setPosition.PositionTop = _positionTop;
            setPosition.ShowDialog();
            _positionLeft = setPosition.PositionLeft;
            _positionTop = setPosition.PositionTop;
        }

        private void ConfigSite_FormClosed(object sender, FormClosedEventArgs e)
        {
            dvmObjects = new DVMObject[hashDVMObjects.Count];
            for (int i = 0; i < hashDVMObjects.Count; i++ )
            {
                dvmObjects[i] = (DVMObject)hashDVMObjects[i];
            }
            _dvmObjects = dvmObjects;
        }

        private void btEdit_Click(object sender, EventArgs e)
        {
            if (lstBox.SelectedIndex != -1)
            {
                lstBox.Enabled = false;
                btEdit.Enabled = false;
                btDelete.Enabled = false;
                tbIP.Focus();

                action = "edit";
                tbIP.Text = ((DVMObject)hashDVMObjects[lstBox.SelectedIndex]).Ip;
                tbRComm.Text = ((DVMObject)hashDVMObjects[lstBox.SelectedIndex]).RComm;
                tbWComm.Text = ((DVMObject)hashDVMObjects[lstBox.SelectedIndex]).WComm;
                _positionLeft = Int32.Parse(((DVMObject)hashDVMObjects[lstBox.SelectedIndex]).Left);
                _positionTop = Int32.Parse(((DVMObject)hashDVMObjects[lstBox.SelectedIndex]).Top);
                gbAdd.Visible = true;
                gbAdd.Text = "Edit the dvm";
                tbIP.Focus();

                this.Width = EXTENDET_WIDTH;
            }
        }
    }
}