/*Class name: AlertSettings
 *Namespace: DVM_Management_Center.Mail
 *Author: Harald Gsoedl
 *Last change: Benno Rott
 *Changed: 07/02/2007
 *Use: Storage class for the alerting procedure.
 */

using System;
using System.Xml.Serialization;
using System.Collections.Generic;
using System.Text;

namespace DVM_Management_Center.Mail
{
    /// <summary>
    /// Provides basic routines to read infos from the DVM. Including all necessary OIDs.
    /// </summary>
    [XmlRoot("Settings")]
    public class AlertSettings
    {
        public AlertSettings()
        {

        }
        [XmlIgnore()]        
        private string _host;
        [XmlElement("Host", DataType = "string")]
        public string Host
        {
            get { return _host; }
            set { _host = value; }
        }
        [XmlIgnore()]        
        private string _port;
        [XmlElement("Port", DataType = "string")]
        public string Port
        {
            get { return _port; }
            set { _port = value; }
        }
        [XmlIgnore()]        
        private string _username;
        [XmlElement("Username", DataType = "string")]
        public string Username
        {
            get { return _username; }
            set { _username = value; }
        }
        [XmlIgnore()]        
        private string _password;
        [XmlElement("Password", DataType = "string")]
        public string Password
        {
            get { return _password; }
            set { _password = value; }
        }
        [XmlIgnore()]
        private string _receiver;
        [XmlElement("Receiver", DataType = "string")]
        public string Receiver
        {
            get { return _receiver; }
            set { _receiver = value; }
        }
        [XmlIgnore()]
        private string _sender;
        [XmlElement("Sender", DataType = "string")]
        public string Sender
        {
            get { return _sender; }
            set { _sender = value; }
        }

        [XmlIgnore()]
        private bool _blConnectivity;
        [XmlElement("BlConnectivity")]
        public bool BlConnectivity
        {
            get { return _blConnectivity; }
            set { _blConnectivity = value; }
        }
        [XmlIgnore()]
        private int _tbConnectivity;
        [XmlElement("TbConnectivity")]
        public int TbConnectivity
        {
            get { return _tbConnectivity; }
            set { _tbConnectivity = value; }
        }

        [XmlIgnore()]
        private bool _blSyncLoss;
        [XmlElement("BlSyncLoss")]
        public bool BlSyncLoss
        {
            get { return _blSyncLoss; }
            set { _blSyncLoss = value; }
        }
        [XmlIgnore()]
        private int _tbSyncLoss;
        [XmlElement("TbSyncLoss")]
        public int TbSyncLoss
        {
            get { return _tbSyncLoss; }
            set { _tbSyncLoss = value; }
        }

        [XmlIgnore()]
        private bool _blAlarm;
        [XmlElement("BlAlarm")]
        public bool BlAlarm
        {
            get { return _blAlarm; }
            set { _blAlarm = value; }
        }
        [XmlIgnore()]
        private int _tbAlarm;
        [XmlElement("TbAlarm")]
        public int TbAlarm
        {
            get { return _tbAlarm; }
            set { _tbAlarm = value; }
        }

        [XmlIgnore()]
        private bool _blEntry;
        [XmlElement("BlEntry")]
        public bool BlEntry
        {
            get { return _blEntry; }
            set { _blEntry = value; }
        }

        [XmlIgnore()]
        private int _hoursDelay;
        [XmlElement("HoursDelay")]
        public int HoursDelay
        {
            get { return _hoursDelay; }
            set { _hoursDelay = value; }
        }
    }
}
