/*Class name: SNMPBasics
 *Namespace: DVM_Management_Center.SNMP
 *Author: Harald Gsoedl
 *Changed: 20/02/2007
 *Use: Provides basic routines to read informations with SNMP.
 */

/*
 * SNMP++.NET v. 1.21
 * Copyright (c) 2003-2006 Military Communication Institute, Zegrze, Poland
 * Author: Marek Malowidzki
 * This software is based on SNMP++ from Jochen Katz, Frank Fock, which is in
 * turn based on SNMP++2.6 from Hewlett Packard:
 * Copyright (c) 2001-2003 Jochen Katz, Frank Fock
 * Copyright (c) 1996 Hewlett-Packard Company
 */
using System;
using System.Collections;
using System.Collections.Generic;
using System.Text;
using SNMPDll;

namespace DVM_Management_Center.SNMP
{
    class SNMPBasics:SNMPHelpers
    {
        private SNMPAgent snmpAgent;

        public SNMPBasics(string ip, string readCommunity, string writeCommunity, string mibPath)
        {
            snmpAgent = new SNMPAgent(ip, readCommunity, writeCommunity);
        }

        protected string GetSimpleSNMPValue(string oid)
        {
            SNMPObject simpVal = new SNMPObject(oid);
            return simpVal.getSimpleValue(snmpAgent).ToString();
        }

        protected void SetIntValue(string oid, int val)
        {
            SNMPObject intVal = new SNMPObject(oid);
            snmpAgent.setValue(intVal, SNMPOIDType.Int, val);
        }
         
        protected Hashtable GetTable(string oid)
        {
            SNMPObject tableRead = new SNMPObject(oid);
            return tableRead.getValue(snmpAgent);
        }

        protected Hashtable GetMultiVals(string[] oids)
        {
            SNMPObject[] mulVals = new SNMPObject[oids.Length];
            for (int i = 0; i < mulVals.Length; i++)
            {
                mulVals[i] = new SNMPObject(oids[i]);
            }
            return snmpAgent.getValues(mulVals);
        }
    }
}
